Program SnowFall;

{ (c) by Tomislav Filipcic }

Uses midas,                    { Main MIDAS Unit }
     mm,                       { MM Module Unit }
     mplayer,                  { Module Player Definitions Unit }
     modp,                     { Protracker Module Playing Unit }
     timer;                    { MIDAS Timer Unit }

const
  Flakes = 3000;       { higher = more flakes }
  Fastest= 240;        { try smaller numbers for slower flakes}

Var r : Word;          { temp var }
    module : pmpmodule;
    framecount,oldcount: integer;
    scrsync:integer;

{$L zvoncici.obj}
Procedure Music; External;     { Music : Unknown author, I got it from a }
                               {         local BBS                       }

{$F+}                          { IMPORTANT }
Procedure preVR;               { This procedure will be called before every }
Begin                          { vertical retrace and it will increase }
  Inc(Framecount);             { the framecount }
End;
{$F-}                          { Also important, unless you want everything }
                               { to be far, it will just slow down the code }

Function KeyPressed : Boolean; Assembler;  { Check if any key was pressed }
Asm
  mov ah,01h
  int 16h
  mov ax,00h
  jz  @1
  inc ax
  @1:
End;

Procedure Perturb;assembler;  {Peturbation algorhythm (C) 1982 BarathSoft}
Asm
  mov dx,r
  xor dx,0aa55h
  shl dx,1
  adc dx,$118
  mov r,dx
End;

Function IsVGA : Boolean; Assembler;   { Check for VGA }
Asm
  mov ah, 12h
  mov al, 00h
  mov bl, 36h
  int 10h
  mov ah, 0
  cmp al, 12h
  jnz @Nope
  inc ah
  @Nope:
End;

Procedure SetVGA; Assembler; { Go to 320x200x256 graphic mode }
Asm
  mov ax,0013h
  int 10h
End;

Procedure SetTEXT; Assembler; { Go to 80x25 text mode }
Asm
  mov ax,0003h
  int 10h
End;

Type FlakeyRec = Record
                    x : Byte;
                    y : Byte;
                    p : Word;
                 End;

Var CurFlake,
    s,
    pf:Word;
    Flake:Array[0..flakes] of flakeyrec;


Procedure Snowing;                     { Snowing procedure by Wil Barath }
Begin
  Repeat
    Oldcount:=Framecount;
    Asm                                { Wait for framecount to change }
      mov ax,oldcount                  { ax:=oldcount }
     @loop:
      mov bx,framecount                { bx:=framecount }
      cmp bx,ax                        { Compare framecount and oldcount }
      je @loop                         { If they are equal goto @loop }
    End;
       Asm
          mov dx,r
          mov cx,flakes                {for CurFlake:= 1 to flakes do}
          mov pf,Offset flake;         {with flake[curflake] do}
          mov ax,0a000h
          mov es,ax                    {begin}
          mov bx,$118
@0:       xor dx,0aa55h                {Perturb }
          shl dx,1
          adc dx,bx
          mov si,pf
          mov di,[si.FlakeyRec.p]
          xor al,al
          mov es:[di],al               {Mem[$a000:p]:=0;}
          cmp dl,[si.FlakeyRec.x]      {If x>=Lo(r) then Inc(p);}
          jnc @1
          inc di
@1:       mov ah,[si.FlakeyRec.y]
          cmp dh,ah                    {If y>=Hi(r) then Inc(p,320);}
          jnc @2
          add di,320
@2:       mov Word Ptr [si.FlakeyRec.p],di
          shr ah,5                     {Mem[$a000:p]:=y SHR 5 + $18;}
          add ah,bl
          mov es:[di],ah
          add pf,Type flakeyRec
          loop @0
          mov r,dx
        End;
    until keypressed;
End;

Begin
  If isVGA=False then halt;            { Exit if a VGA card was not fount }
  For CurFlake:=0 to Flakes do With Flake[curflake] do
    begin                              { set up snow lookup table }
      Perturb;
      Inc(s,r);
      y:=Hi(Hi(r)*fastest)+5;
      x:=Hi(Lo(r)*y)+1;                {limit x movement}
      p:=s;
  end;
  tmrgetscrsync(@scrsync);             { Init the timer }
  MidasSetDefaults;                    { Which sound card do you have? }
  MidasInit;                           { Initilize! If you do not have a sound }
                                       { card keep "playing" so that we can }
                                       { use the timer }
  module:=MidasPrepareMM(@music,@mpMOD); { Prepare the MM module (which is }
                                       { with the exe) for playing }
  MidasPlayModule(module,0);           { Play the music }
  SetVGA;                              { Enter 320x200x256 mode }
  TmrSyncScr(scrSync,@preVR,nil,nil ); { Now the function preVR will be }
                                       { called before a vertical retrace }
  Snowing;                             { Start the snow. It will last until }
                                       { a key is pressed. The key checking }
                                       { is in the procedure Snowing }
  tmrstopscrsync;                      { Stop timer... }
  MidasStopModule(module);             { Stop playing, free all the memory }
  MidasFreeMM(module);                 { and all other stuff }
  MidasClose;
  SetText;                             { Go back 80x25 mode }
end.

